/*
 * vm2emul.js : JavaScript/HTML emulation of the VM-2 Conventional Machine
 *
 * version 1.1, June 23, 2000
 *
 * Copyright C 2000 by Giovanni Chiola <chiola@disi.unige.it>
 *                     DISI, Universita' di Genova
 *                     via Dodecaneso 35, 16146 Genova, Italy.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See URL http://www.gnu.org/copyleft/gpl.html for details.
 */

mydisplRAM = 200
myRAM = new Array

myPC = 0
myFP = 0
mySP = 0
myACC = 0
myIR = 0
myImmreg = 0x8000
myOmmreg = 0x8000
myEmulState = 0
myCurrInstr = 0
myCurrOp = 0
myClock = 0
mySTEP = 0
myHALT = false
mySchedOut = 0

myramCoding = 3
mystckCoding = 3
mySPCoding = 3
myFPCoding = 3
myPCCoding = 3
myACCCoding = 3
myIRCoding = 3
myIdevCoding = 3
myOdevCoding = 3
myOutDelay = 3

myFileCoding = 16

function resetram() {
  var i = 0

  for (i=0 ; i < 4094 ; i++)
    myRAM[i] = 0
}

function setfilecoding() {
  if ( parent.controlFrame.document.controlForm.filecoding.options[0].selected ) {
      myFileCoding = 10
  } else
  if ( parent.controlFrame.document.controlForm.filecoding.options[1].selected ) {
      myFileCoding = 2
  } else
  if ( parent.controlFrame.document.controlForm.filecoding.options[2].selected ) {
      myFileCoding = 8
  } else
  if ( parent.controlFrame.document.controlForm.filecoding.options[3].selected )
      myFileCoding = 16
}

function setramcoding() {
  var i = 0
  for ( i = 0 ; i < 5 ; i++ ) {
    if ( parent.controlFrame.document.controlForm.ramcoding.options[i].selected ) {
        myramCoding = i
        reprintram()
        break
      }
  }
}

function setstckcoding() {
  var i = 0
  for ( i = 0 ; i < 5 ; i++ ) {
    if ( parent.controlFrame.document.controlForm.stckcoding.options[i].selected ) {
        mystckCoding = i
        reprintstck()
        break
      }
  }
}

function setSPcoding() {
  var i = 0
  for ( i = 0 ; i < 4 ; i++ ) {
    if ( parent.cpuFrame.document.cpuForm.SPcoding.options[i].selected ) {
        mySPCoding = i
        reprintSP()
        break
      }
  }
}

function setFPcoding() {
  var i = 0
  for ( i = 0 ; i < 4 ; i++ ) {
    if ( parent.cpuFrame.document.cpuForm.FPcoding.options[i].selected ) {
        myFPCoding = i
        reprintFP()
        break
      }
  }
}

function setPCcoding() {
  var i = 0
  for ( i = 0 ; i < 4 ; i++ ) {
    if ( parent.cpuFrame.document.cpuForm.PCcoding.options[i].selected ) {
        myPCCoding = i
        reprintPC()
        break
      }
  }
}

function setACCcoding() {
  var i = 0
  for ( i = 0 ; i < 5 ; i++ ) {
    if ( parent.cpuFrame.document.cpuForm.ACCcoding.options[i].selected ) {
        myACCCoding = i
        reprintACC()
        break
      }
  }
}

function setIRcoding() {
  var i = 0
  for ( i = 0 ; i < 4 ; i++ ) {
    if ( parent.cpuFrame.document.cpuForm.IRcoding.options[i].selected ) {
        myIRCoding = i
        reprintIR()
        break
      }
  }
}

function setIdevcoding() {
  var i = 0
  for ( i = 0 ; i < 4 ; i++ ) {
    if ( parent.ioFrame.document.ioForm.Idevcoding.options[i].selected ) {
        myIdevCoding = i
        reprintIdev()
        break
      }
  }
}

function setOdevcoding() {
  var i = 0
  for ( i = 0 ; i < 4 ; i++ ) {
    if ( parent.ioFrame.document.ioForm.Odevcoding.options[i].selected ) {
        myOdevCoding = i
        reprintOdev()
        break
      }
  }
}

function printnumb(myCoding,noBits,i) {
  var j = 0
  var k = 0
  var l = 0
  var mask = 32768
  var str = ""

  if ( myCoding == 0 ) {
    if ( (i < 10) && (noBits > 12) )
      return("U 0000"+i)
    else if ( (i < 10) || ((i < 100) && (noBits > 12)) )
      return("U 000"+i)
    else if ( (i < 100) || ((i < 1000) && (noBits > 12)) )
      return("U 00"+i)
    else if ( (i < 1000) || ((i < 10000) && (noBits > 12)) )
      return("U 0"+i)
    else
      return("U "+i)
  } else if ( myCoding == 1 ) {
    mask = 1 << (noBits-1)
    str = "B "
    for (j=noBits ; j > 0 ; j--) {
        if ( i & mask )
          str += "1"
        else
          str += "0"
        mask >>= 1
      }
    return(str)
  } else if ( myCoding == 2 ) {
    str = ""
    mask = 7
    l = i
    for (j=(noBits+2)/3 ; j >= 1 ; j--) {
        k = l & mask;
        if ( k < 4 ) {
          if ( k < 2 ) {
            if ( k < 1 )
              str = "0"+str
            else
              str = "1"+str
          } else {
            if ( k < 3 )
              str = "2"+str
            else
              str = "3"+str
          }
        } else {
          if ( k < 6 ) {
            if ( k < 5 )
              str = "4"+str
            else
              str = "5"+str
          } else {
            if ( k < 7 )
              str = "6"+str
            else
              str = "7"+str
          }
        }
        l = l / 8
      }
    return("O "+str)
  } else if ( myCoding == 3 ) {
    str = ""
    mask = 15
    l = i
    for (j=(noBits+3), j >>= 2 ; j > 0 ; j--) {
        k = l & mask;
        if ( k < 8 ) {
          if ( k < 4 ) {
            if ( k < 2 ) {
              if ( k < 1 )
                str = "0"+str
              else
                str = "1"+str
            } else {
              if ( k < 3 )
                str = "2"+str
              else
                str = "3"+str
            }
          } else {
            if ( k < 6 ) {
              if ( k < 5 )
                str = "4"+str
              else
                str = "5"+str
            } else {
              if ( k < 7 )
                str = "6"+str
              else
                str = "7"+str
            }
          }
        } else {
          if ( k < 12 ) {
            if ( k < 10 ) {
              if ( k < 9 )
                str = "8"+str
              else
                str = "9"+str
            } else {
              if ( k < 11 )
                str = "A"+str
              else
                str = "B"+str
            }
          } else {
            if ( k < 14 ) {
              if ( k < 13 )
                str = "C"+str
              else
                str = "D"+str
            } else {
              if ( k < 15 )
                str = "E"+str
              else
                str = "F"+str
            }
          }
        }
        l = l / 16
      }
    return("H "+str)
  } else if ( myCoding == 4 ) {
    str = "D "
    mask = 1<<(noBits -1)
    if ( i & mask ) {
      str += "-"
      i ^= 0xFFF
      if ( noBits > 12 )
        i ^= 0xF000
      i += 1
      i &= 0xFFFF
      if ( noBits == 12 )
        i &= 0xFFF
    }
    return(str+i)
  }
}

function printcell(doc,myCod,i) {
 var myzeros = ""
 if ( i < 1000 ) {
   if ( i < 10 )
    myzeros = "000"
   else if ( i < 100 )
    myzeros = "00"
   else
    myzeros = "0"
  }
  doc.write("<TR><TD><A NAME='addr"+i+"'>"+myzeros+i+
    "</A><TD>:<TD><INPUT type='text' readonly value='"+
    printnumb(myCod,16,myRAM[i])+"' size='18' name='txt" + i + "'>")
}

function reprintram() {
  var i = 0
  for ( i = 0 ; i < mydisplRAM ; i++ )

    parent.programFrame.document.programramForm.elements[i].value = printnumb(myramCoding,16,myRAM[i])
}

function reprintstck() {
  var i = 0
  var j = 4094-mydisplRAM
  for ( i = 0 ; i < mydisplRAM ; i++, j++ )
    parent.stackFrame.document.stackramForm.elements[i].value = printnumb(mystckCoding,16,myRAM[j])
}

function reprintSP() {
  parent.cpuFrame.document.cpuForm.regSP.value = printnumb(mySPCoding,12,mySP)
}

function reprintFP() {
  parent.cpuFrame.document.cpuForm.regFP.value = printnumb(myFPCoding,12,myFP)
}

function reprintPC() {
  parent.cpuFrame.document.cpuForm.regPC.value = printnumb(myPCCoding,12,myPC)
}

function reprintACC() {
  parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
}

function reprintIR() {
  parent.cpuFrame.document.cpuForm.regIR.value = printnumb(myIRCoding,16,myIR)
}

function reprintIdev() {
  parent.ioFrame.document.ioForm.RAM4094.value = printnumb(myIdevCoding,16,myImmreg)
}

function reprintOdev() {
  parent.ioFrame.document.ioForm.RAM4095.value = printnumb(myOdevCoding,16,myOmmreg)
}

function generatecodoptions(doc,no_opts) {
  doc.write("<OPTION>uns. dec.</OPTION><OPTION>binary</OPTION>"+
            "<OPTION>octal</OPTION><OPTION selected>hexadecimal</OPTION>")
  if ( no_opts > 4 )
    doc.write("<OPTION>signed dec.</OPTION>")
  doc.write("</SELECT>")
}

function signed_short(sign_bit,val) {
  var sss = 1<<sign_bit
  var mask = sss-1
  var str = " "
  if ( val & sss ) {
    str += "-"
    val ^= mask
    val++
    val &= mask
  }
  return(str+val)
}

function printinstr(CurInstr,CurOp) {
  if ( CurInstr == 0 )
    return("JPOS "+CurOp)
  if ( CurInstr == 1 )
    return("JNEG "+CurOp)
  if ( CurInstr == 2 )
    return("JZER "+CurOp)
  if ( CurInstr == 3 )
    return("JNZE "+CurOp)
  if ( CurInstr == 4 )
    return("LODD "+CurOp)
  if ( CurInstr == 5 )
    return("ADDD "+CurOp)
  if ( CurInstr == 6 )
    return("ANDD "+CurOp)
  if ( CurInstr == 7 )
    return("STOD "+CurOp)
  if ( CurInstr == 8 )
    return("LODL"+signed_short(11,CurOp))
  if ( CurInstr == 9 )
    return("ADDL"+signed_short(11,CurOp))
  if ( CurInstr == 10 )
    return("ANDL"+signed_short(11,CurOp))
  if ( CurInstr == 11 )
    return("STOL"+signed_short(11,CurOp))
  if ( CurInstr == 12 )
    return("JUMP "+CurOp)
  if ( CurInstr == 13 )
    return("LDIX"+signed_short(11,CurOp))
  if ( CurInstr == 14 )
    return("CALL "+CurOp)
  if ( CurInstr == 15 )
    return("LOC8 "+CurOp)
  if ( CurInstr == 16 )
    return("LOCH "+CurOp)
  if ( CurInstr == 17 )
    return("INSP "+CurOp)
  if ( CurInstr == 18 )
    return("DESP "+CurOp)
  if ( CurInstr == 19 )
    return("PUSH")
  if ( CurInstr == 20 )
    return("PSHI")
  if ( CurInstr == 21 )
    return("POP")
  if ( CurInstr == 22 )
    return("POPI")
  if ( CurInstr == 23 )
    return("SWAS")
  if ( CurInstr == 24 )
    return("SWAF")
  if ( CurInstr == 25 )
    return("NEGA")
  if ( CurInstr == 26 )
    return("SIGN")
  if ( CurInstr == 27 )
    return("RETN")
  if ( CurInstr == 28 )
    return("HALT")
  if ( CurInstr == 29 )
    return("RSHF")
  if ( CurInstr == 30 )
    return("LSHF")
  return("???")
}

function emulate_mem_write(Addr,Val) {
  var aux = 0
  if ( Addr < 4094 ) {
    myRAM[Addr] = Val 
    if ( Addr < mydisplRAM )
      parent.programFrame.document.programramForm.elements[Addr].value = printnumb(myramCoding,16,Val)
    aux = 4094-mydisplRAM
    if ( Addr >= aux )
      parent.stackFrame.document.stackramForm.elements[Addr-aux].value = printnumb(mystckCoding,16,Val)
  } else {
    if ( Addr == 4095 ) {
      myOmmreg = Val
      parent.ioFrame.document.ioForm.RAM4095.value = printnumb(myOdevCoding,16,myOmmreg)
      if ( ! (Val & 0x8000) )
        mySchedOut = myClock+myOutDelay+1
    }
  }
}

function emulate_mem_read(Addr) {
  var aux = 0
  if ( Addr < 4094 )
    aux = myRAM[Addr]
  else if ( Addr == 4094 ) {
    aux = myImmreg
    myImmreg |= 0x8000
    parent.ioFrame.document.ioForm.RAM4094.value = printnumb(myIdevCoding,16,myImmreg)
    parent.ioFrame.document.ioForm.input_dev.value = ""
  } else if ( Addr == 4095 )
    aux = myOmmreg
  return(aux)
}

function change_PC() {
  var aux = myPC
  if ( aux >= 1 )
    aux--
  parent.cpuFrame.document.cpuForm.regPC.value = printnumb(myPCCoding,16,myPC)
  parent.programFrame.location = "ram_prgm.htm#addr"+aux
}

function change_SP() {
  parent.cpuFrame.document.cpuForm.regSP.value = printnumb(mySPCoding,12,mySP)
  parent.stackFrame.location = "ram_stck.htm#addr"+mySP
}

function emulate_fetch() {
  if ( (myEmulState != 1) && ! myHALT ) {
    myEmulState = 1
    parent.cpuFrame.document.cpuForm.fetchstep.disabled = true
    parent.cpuFrame.document.cpuForm.execstep.disabled = false
    myIR = emulate_mem_read(myPC)
    myPC++
  }
  change_PC()
  parent.cpuFrame.document.cpuForm.regIR.value = printnumb(myIRCoding,16,myIR)
  myCurrInstr = myIR >>> 12
  if ( myCurrInstr == 15 ) {
    myCurrOp = myIR & 0xF00
    myCurrInstr += (myCurrOp >> 8)
    myCurrOp = myIR & 0xFF
  } else
    myCurrOp = myIR & 0xFFF
  parent.cpuFrame.document.cpuForm.curr_instr.value = printinstr(myCurrInstr,myCurrOp)
}

function emulate_exec() {
  var aux = 0
  if ( (myEmulState == 1) && ! myHALT ) {
    myEmulState = 2
    parent.cpuFrame.document.cpuForm.fetchstep.disabled = false
    parent.cpuFrame.document.cpuForm.execstep.disabled = true
    switch (myCurrInstr) {
    case 0:
       if ( !(myACC & 0x8000) ) {
         myPC = myCurrOp
         change_PC()
       }
     break
    case 1:
       if ( (myACC & 0x8000) ) {
         myPC = myCurrOp
         change_PC()
       }
     break
    case 2:
       if ( myACC == 0 ) {
         myPC = myCurrOp
         change_PC()
       }
     break
    case 3:
       if ( myACC != 0 ) {
         myPC = myCurrOp
         change_PC()
       }
     break
    case 4:
       myACC = emulate_mem_read(myCurrOp)
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    case 5:
       myACC += emulate_mem_read(myCurrOp)
       myACC &= 0xFFFF
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    case 6:
       myACC &= emulate_mem_read(myCurrOp)
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    case 7:
       emulate_mem_write(myCurrOp,myACC)
     break
    case 8:
       aux = myCurrOp + myFP
       aux &= 0xFFF
       myACC = emulate_mem_read(aux)
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    case 9:
       aux = myCurrOp + myFP
       aux &= 0xFFF
       myACC += emulate_mem_read(aux)
       myACC &= 0xFFFF
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    case 10:
       aux = myCurrOp + myFP
       aux &= 0xFFF
       myACC &= emulate_mem_read(aux)
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    case 11:
       aux = myCurrOp + myFP
       aux &= 0xFFF
       emulate_mem_write(aux,myACC)
     break
    case 12:
       myPC = myCurrOp
       change_PC()
     break
    case 13:
       aux = myCurrOp + myACC
       aux &= 0xFFF
       myACC = emulate_mem_read(aux)
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    case 14:
       emulate_mem_write(mySP,myFP)
       myFP = mySP
       parent.cpuFrame.document.cpuForm.regFP.value = printnumb(myFPCoding,12,myFP)
       mySP--
       emulate_mem_write(mySP,myPC)
       mySP--
       change_SP()
       myPC = myCurrOp
       change_PC()
     break
    case 15:
       myACC = 0xFF & myCurrOp
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    case 16:
       myACC &= 0xFF
       myACC |= ((0xFF & myCurrOp)<<8)
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    case 17:
       mySP += (myCurrOp & 0xFF)
       mySP &= 0xFFF
       change_SP()
     break
    case 18:
       mySP -= (myCurrOp & 0xFF)
       mySP &= 0xFFF
       change_SP()
     break
    case 19:
       emulate_mem_write(mySP,myACC)
       mySP--
       mySP &= 0xFFF
       change_SP()
     break
    case 20:
       aux = emulate_mem_read(myACC & 0xFFF)
       emulate_mem_write(mySP,aux)
       mySP--
       mySP &= 0xFFF
       change_SP()
     break
    case 21:
       mySP++
       mySP &= 0xFFF
       change_SP()
       myACC = emulate_mem_read(mySP)
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    case 22:
       mySP++
       mySP &= 0xFFF
       change_SP()
       aux = emulate_mem_read(mySP)
       emulate_mem_write(myACC & 0xFFF,aux)
     break
    case 23:
       aux = (myACC & 0xFFF)
       myACC = mySP
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
       mySP = aux
       change_SP()
     break
    case 24:
       aux = (myACC & 0xFFF)
       myACC = myFP
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
       myFP = aux
       parent.cpuFrame.document.cpuForm.regFP.value = printnumb(myFPCoding,12,myFP)
     break
    case 25:
       myACC ^= 0xFFFF
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    case 26:
       myACC ^= 0xFFFF
       myACC++
       myACC &= 0xFFFF
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    case 27:
       mySP = myFP
       change_SP()
       aux = (myFP-1) & 0xFFF
       myPC = emulate_mem_read(aux)
       myPC &= 0xFFF
       change_PC()
       myFP = emulate_mem_read(mySP)
       myFP &= 0xFFF
       parent.cpuFrame.document.cpuForm.regFP.value = printnumb(myFPCoding,12,myFP)
     break
    case 28:
       myHALT = true
       parent.cpuFrame.document.cpuForm.fetchstep.disabled = true
       parent.cpuFrame.document.cpuForm.execstep.disabled = true
     break
    case 29:
       myACC >>>= 1
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    case 30:
       myACC <<= 1
       myACC &= 0xFFFF
       parent.cpuFrame.document.cpuForm.regACC.value = printnumb(myACCCoding,16,myACC)
     break
    default:
     break
    }
    myClock++
    parent.cpuFrame.document.cpuForm.clock_count.value = ""+myClock
    if ( mySchedOut > 0 ) {
      if ( myHALT || (mySchedOut <= myClock) )
        put_output()
    }
    if ( ! myHALT )
      parent.cpuFrame.document.cpuForm.curr_instr.value = ""
  }
}

function get_input() {
  var mystr = new String(parent.ioFrame.document.ioForm.input_dev.value)
  var aux = mystr.charCodeAt(0)
  if ( mystr.length > 0 ) {
    myImmreg = (aux & 0x7F)
    parent.ioFrame.document.ioForm.RAM4094.value = printnumb(myIdevCoding,16,myImmreg)
  }
}

function get_output_delay() {
  myOutDelay = parseInt(parent.ioFrame.document.ioForm.output_delay.value)
  if ( myOutDelay < 1 )
    myOutDelay = 1
}

function put_output() {
  var aux = myOmmreg & 0x7F
  myOmmreg |= 0x8000
  parent.ioFrame.document.ioForm.RAM4095.value = printnumb(myOdevCoding,16,myOmmreg)
  parent.ioFrame.document.ioForm.output_dev.value += String.fromCharCode(aux)
  mySchedOut = 0
}

function start_run() {
  mySTEP = parseInt(parent.cpuFrame.document.cpuForm.no_clock.value,10)
  while ( mySTEP > 0 ) {
    mySTEP--
    emulate_fetch()
    emulate_exec()
    if ( parent.cpuFrame.document.cpuForm.stoprun.checked )
      mySTEP = 0
  }
}

function stop_run() {
  mySTEP = 0
}

function refresh_all() {
  reprintram()
  reprintstck()
  change_SP()
  reprintFP()
  change_PC()
  reprintACC()
  reprintIR()
  reprintIdev()
  reprintOdev()
}

function reset_VM2() {
  resetram()
  myPC = 0
  myFP = 0
  mySP = 0
  myACC = 0
  myIR = 0
  myImmreg = 0x8000
  myOmmreg = 0x8000
  mySchedOut = 0
  myEmulState = 0
  myCurrInstr = 0
  myCurrOp = 0
  myClock = 0
  mySTEP = 0
  myHALT = false
  refresh_all()
  parent.ioFrame.document.ioForm.input_dev.value = ""
  parent.ioFrame.document.ioForm.output_dev.value = ""
  parent.cpuFrame.document.cpuForm.clock_count.value = "0"
  parent.cpuFrame.document.cpuForm.curr_instr.value = ""
}

function load_file() {
  var filn = parent.controlFrame.document.controlForm.VM2_program_file.value
  var myarr = parent.controlFrame.document.applets[0].RamLines(filn)
  var i = 0
  var mystr = ""
  var j = 0
  reset_VM2()
  for ( mystr = myarr[0] ; mystr != null ; i++, mystr = myarr[i] ) {
    j = parseInt(mystr,myFileCoding)
    if ( j == NaN )
      break
    j &= 0xFFFF
    myRAM[i] = j
  }
  refresh_all()
}

resetram()

